04b4a7956a58d5db9bdeae5188c958030a24ae7c
[arvados.git] / build / run-build-packages.sh
1 #!/bin/bash
2 # Copyright (C) The Arvados Authors. All rights reserved.
3 #
4 # SPDX-License-Identifier: AGPL-3.0
5
6 . `dirname "$(readlink -f "$0")"`/run-library.sh
7 . `dirname "$(readlink -f "$0")"`/libcloud-pin.sh
8
9 read -rd "\000" helpmessage <<EOF
10 $(basename $0): Build Arvados packages
11
12 Syntax:
13         WORKSPACE=/path/to/arvados $(basename $0) [options]
14
15 Options:
16
17 --build-bundle-packages  (default: false)
18     Build api server and workbench packages with vendor/bundle included
19 --debug
20     Output debug information (default: false)
21 --target <target>
22     Distribution to build packages for (default: debian8)
23 --only-build <package>
24     Build only a specific package (or $ONLY_BUILD from environment)
25 --command
26     Build command to execute (defaults to the run command defined in the
27     Docker image)
28
29 WORKSPACE=path         Path to the Arvados source tree to build packages from
30
31 EOF
32
33 EXITCODE=0
34 DEBUG=${ARVADOS_DEBUG:-0}
35 TARGET=debian8
36 COMMAND=
37
38 PARSEDOPTS=$(getopt --name "$0" --longoptions \
39     help,build-bundle-packages,debug,target:,only-build: \
40     -- "" "$@")
41 if [ $? -ne 0 ]; then
42     exit 1
43 fi
44
45 eval set -- "$PARSEDOPTS"
46 while [ $# -gt 0 ]; do
47     case "$1" in
48         --help)
49             echo >&2 "$helpmessage"
50             echo >&2
51             exit 1
52             ;;
53         --target)
54             TARGET="$2"; shift
55             ;;
56         --only-build)
57             ONLY_BUILD="$2"; shift
58             ;;
59         --debug)
60             DEBUG=1
61             ;;
62         --command)
63             COMMAND="$2"; shift
64             ;;
65         --)
66             if [ $# -gt 1 ]; then
67                 echo >&2 "$0: unrecognized argument '$2'. Try: $0 --help"
68                 exit 1
69             fi
70             ;;
71     esac
72     shift
73 done
74
75 if [[ "$COMMAND" != "" ]]; then
76   COMMAND="/usr/local/rvm/bin/rvm-exec default bash /jenkins/$COMMAND --target $TARGET"
77 fi
78
79 STDOUT_IF_DEBUG=/dev/null
80 STDERR_IF_DEBUG=/dev/null
81 DASHQ_UNLESS_DEBUG=-q
82 if [[ "$DEBUG" != 0 ]]; then
83     STDOUT_IF_DEBUG=/dev/stdout
84     STDERR_IF_DEBUG=/dev/stderr
85     DASHQ_UNLESS_DEBUG=
86 fi
87
88 declare -a PYTHON_BACKPORTS PYTHON3_BACKPORTS
89
90 PYTHON2_VERSION=2.7
91 PYTHON3_VERSION=$(python3 -c 'import sys; print("{v.major}.{v.minor}".format(v=sys.version_info))')
92
93 ## These defaults are suitable for any Debian-based distribution.
94 # You can customize them as needed in distro sections below.
95 PYTHON2_PACKAGE=python$PYTHON2_VERSION
96 PYTHON2_PKG_PREFIX=python
97 PYTHON2_PREFIX=/usr
98 PYTHON2_INSTALL_LIB=lib/python$PYTHON2_VERSION/dist-packages
99
100 PYTHON3_PACKAGE=python$PYTHON3_VERSION
101 PYTHON3_PKG_PREFIX=python3
102 PYTHON3_PREFIX=/usr
103 PYTHON3_INSTALL_LIB=lib/python$PYTHON3_VERSION/dist-packages
104 ## End Debian Python defaults.
105
106 case "$TARGET" in
107     debian*)
108         FORMAT=deb
109         ;;
110     ubuntu*)
111         FORMAT=deb
112         ;;
113     centos*)
114         FORMAT=rpm
115         PYTHON2_PACKAGE=$(rpm -qf "$(which python$PYTHON2_VERSION)" --queryformat '%{NAME}\n')
116         PYTHON2_PKG_PREFIX=$PYTHON2_PACKAGE
117         PYTHON2_INSTALL_LIB=lib/python$PYTHON2_VERSION/site-packages
118         PYTHON3_PACKAGE=$(rpm -qf "$(which python$PYTHON3_VERSION)" --queryformat '%{NAME}\n')
119         PYTHON3_PKG_PREFIX=$PYTHON3_PACKAGE
120         PYTHON3_PREFIX=/opt/rh/rh-python35/root/usr
121         PYTHON3_INSTALL_LIB=lib/python$PYTHON3_VERSION/site-packages
122         export PYCURL_SSL_LIBRARY=nss
123         ;;
124     *)
125         echo -e "$0: Unknown target '$TARGET'.\n" >&2
126         exit 1
127         ;;
128 esac
129
130
131 if ! [[ -n "$WORKSPACE" ]]; then
132   echo >&2 "$helpmessage"
133   echo >&2
134   echo >&2 "Error: WORKSPACE environment variable not set"
135   echo >&2
136   exit 1
137 fi
138
139 # Test for fpm
140 fpm --version >/dev/null 2>&1
141
142 if [[ "$?" != 0 ]]; then
143   echo >&2 "$helpmessage"
144   echo >&2
145   echo >&2 "Error: fpm not found"
146   echo >&2
147   exit 1
148 fi
149
150 PYTHON2_FPM_INSTALLER=(--python-easyinstall "$(find_python_program easy_install-$PYTHON2_VERSION easy_install)")
151 install3=$(find_python_program easy_install-$PYTHON3_VERSION easy_install3 pip-$PYTHON3_VERSION pip3)
152 if [[ $install3 =~ easy_ ]]; then
153     PYTHON3_FPM_INSTALLER=(--python-easyinstall "$install3")
154 else
155     PYTHON3_FPM_INSTALLER=(--python-pip "$install3")
156 fi
157
158 RUN_BUILD_PACKAGES_PATH="`dirname \"$0\"`"
159 RUN_BUILD_PACKAGES_PATH="`( cd \"$RUN_BUILD_PACKAGES_PATH\" && pwd )`"  # absolutized and normalized
160 if [ -z "$RUN_BUILD_PACKAGES_PATH" ] ; then
161   # error; for some reason, the path is not accessible
162   # to the script (e.g. permissions re-evaled after suid)
163   exit 1  # fail
164 fi
165
166 debug_echo "$0 is running from $RUN_BUILD_PACKAGES_PATH"
167 debug_echo "Workspace is $WORKSPACE"
168
169 if [[ -f /etc/profile.d/rvm.sh ]]; then
170     source /etc/profile.d/rvm.sh
171     GEM="rvm-exec default gem"
172 else
173     GEM=gem
174 fi
175
176 # Make all files world-readable -- jenkins runs with umask 027, and has checked
177 # out our git tree here
178 chmod o+r "$WORKSPACE" -R
179
180 # More cleanup - make sure all executables that we'll package are 755
181 cd "$WORKSPACE"
182 find -type d -name 'bin' |xargs -I {} find {} -type f |xargs -I {} chmod 755 {}
183
184 # Now fix our umask to something better suited to building and publishing
185 # gems and packages
186 umask 0022
187
188 debug_echo "umask is" `umask`
189
190 if [[ ! -d "$WORKSPACE/packages/$TARGET" ]]; then
191   mkdir -p $WORKSPACE/packages/$TARGET
192   chown --reference="$WORKSPACE" "$WORKSPACE/packages/$TARGET"
193 fi
194
195 # Perl packages
196 debug_echo -e "\nPerl packages\n"
197
198 if [[ -z "$ONLY_BUILD" ]] || [[ "libarvados-perl" = "$ONLY_BUILD" ]] ; then
199   cd "$WORKSPACE/sdk/perl"
200   libarvados_perl_version="$(version_from_git)"
201
202   cd $WORKSPACE/packages/$TARGET
203   test_package_presence libarvados-perl "$libarvados_perl_version"
204
205   if [[ "$?" == "0" ]]; then
206     cd "$WORKSPACE/sdk/perl"
207
208     if [[ -e Makefile ]]; then
209       make realclean >"$STDOUT_IF_DEBUG"
210     fi
211     find -maxdepth 1 \( -name 'MANIFEST*' -or -name "libarvados-perl*.$FORMAT" \) \
212         -delete
213     rm -rf install
214
215     perl Makefile.PL INSTALL_BASE=install >"$STDOUT_IF_DEBUG" && \
216         make install INSTALLDIRS=perl >"$STDOUT_IF_DEBUG" && \
217         fpm_build install/lib/=/usr/share libarvados-perl \
218         "Curoverse, Inc." dir "$(version_from_git)" install/man/=/usr/share/man \
219         "$WORKSPACE/apache-2.0.txt=/usr/share/doc/libarvados-perl/apache-2.0.txt" && \
220         mv --no-clobber libarvados-perl*.$FORMAT "$WORKSPACE/packages/$TARGET/"
221   fi
222 fi
223
224 # Ruby gems
225 debug_echo -e "\nRuby gems\n"
226
227 FPM_GEM_PREFIX=$($GEM environment gemdir)
228
229 cd "$WORKSPACE/sdk/ruby"
230 handle_ruby_gem arvados
231
232 cd "$WORKSPACE/sdk/cli"
233 handle_ruby_gem arvados-cli
234
235 cd "$WORKSPACE/services/login-sync"
236 handle_ruby_gem arvados-login-sync
237
238 # Python packages
239 debug_echo -e "\nPython packages\n"
240
241 cd "$WORKSPACE/sdk/pam"
242 handle_python_package
243
244 cd "$WORKSPACE/sdk/python"
245 handle_python_package
246
247 cd "$WORKSPACE/sdk/cwl"
248 handle_python_package
249
250 cd "$WORKSPACE/services/fuse"
251 handle_python_package
252
253 cd "$WORKSPACE/services/nodemanager"
254 handle_python_package
255
256 # arvados-src
257 (
258     cd "$WORKSPACE"
259     COMMIT_HASH=$(format_last_commit_here "%H")
260     arvados_src_version="$(version_from_git)"
261
262     cd $WORKSPACE/packages/$TARGET
263     test_package_presence arvados-src $arvados_src_version src ""
264
265     if [[ "$?" == "0" ]]; then
266       cd "$WORKSPACE"
267       SRC_BUILD_DIR=$(mktemp -d)
268       # mktemp creates the directory with 0700 permissions by default
269       chmod 755 $SRC_BUILD_DIR
270       git clone $DASHQ_UNLESS_DEBUG "$WORKSPACE/.git" "$SRC_BUILD_DIR"
271       cd "$SRC_BUILD_DIR"
272
273       # go into detached-head state
274       git checkout $DASHQ_UNLESS_DEBUG "$COMMIT_HASH"
275       echo "$COMMIT_HASH" >git-commit.version
276
277       cd "$SRC_BUILD_DIR"
278       PKG_VERSION=$(version_from_git)
279       cd $WORKSPACE/packages/$TARGET
280       fpm_build $SRC_BUILD_DIR/=/usr/local/arvados/src arvados-src 'Curoverse, Inc.' 'dir' "$PKG_VERSION" "--exclude=usr/local/arvados/src/.git" "--url=https://arvados.org" "--license=GNU Affero General Public License, version 3.0" "--description=The Arvados source code" "--architecture=all"
281
282       rm -rf "$SRC_BUILD_DIR"
283
284     fi
285 )
286
287 # Go binaries
288 cd $WORKSPACE/packages/$TARGET
289 export GOPATH=$(mktemp -d)
290 go get github.com/kardianos/govendor
291 package_go_binary cmd/arvados-client arvados-client \
292     "Arvados command line tool (beta)"
293 package_go_binary cmd/arvados-server arvados-server \
294     "Arvados server daemons"
295 package_go_binary cmd/arvados-server arvados-controller \
296     "Arvados cluster controller daemon"
297 package_go_binary sdk/go/crunchrunner crunchrunner \
298     "Crunchrunner executes a command inside a container and uploads the output"
299 package_go_binary services/arv-git-httpd arvados-git-httpd \
300     "Provide authenticated http access to Arvados-hosted git repositories"
301 package_go_binary services/crunch-dispatch-local crunch-dispatch-local \
302     "Dispatch Crunch containers on the local system"
303 package_go_binary services/crunch-dispatch-slurm crunch-dispatch-slurm \
304     "Dispatch Crunch containers to a SLURM cluster"
305 package_go_binary services/crunch-run crunch-run \
306     "Supervise a single Crunch container"
307 package_go_binary services/crunchstat crunchstat \
308     "Gather cpu/memory/network statistics of running Crunch jobs"
309 package_go_binary services/health arvados-health \
310     "Check health of all Arvados cluster services"
311 package_go_binary services/keep-balance keep-balance \
312     "Rebalance and garbage-collect data blocks stored in Arvados Keep"
313 package_go_binary services/keepproxy keepproxy \
314     "Make a Keep cluster accessible to clients that are not on the LAN"
315 package_go_binary services/keepstore keepstore \
316     "Keep storage daemon, accessible to clients on the LAN"
317 package_go_binary services/keep-web keep-web \
318     "Static web hosting service for user data stored in Arvados Keep"
319 package_go_binary services/ws arvados-ws \
320     "Arvados Websocket server"
321 package_go_binary tools/sync-groups arvados-sync-groups \
322     "Synchronize remote groups into Arvados from an external source"
323 package_go_binary tools/keep-block-check keep-block-check \
324     "Verify that all data from one set of Keep servers to another was copied"
325 package_go_binary tools/keep-rsync keep-rsync \
326     "Copy all data from one set of Keep servers to another"
327 package_go_binary tools/keep-exercise keep-exercise \
328     "Performance testing tool for Arvados Keep"
329
330 # The Python SDK
331 fpm_build_virtualenv "arvados-python-client" "sdk/python"
332 fpm_build_virtualenv "arvados-python-client" "sdk/python" "python3"
333
334 # Arvadow cwl runner
335 fpm_build_virtualenv "arvados-cwl-runner" "sdk/cwl"
336
337 # The PAM module
338 if [[ $TARGET =~ debian|ubuntu ]]; then
339     cd $WORKSPACE/packages/$TARGET
340     rm -rf "$WORKSPACE/sdk/pam/build"
341     libpam_arvados_version=$(awk '($1 == "Version:"){print $2}' $WORKSPACE/sdk/pam/arvados_pam.egg-info/PKG-INFO)
342     test_package_presence libpam-arvados "$libpam_arvados_version" python
343     if [[ "$?" == "0" ]]; then
344       fpm_build $WORKSPACE/sdk/pam libpam-arvados 'Curoverse, Inc.' 'python' "$libpam_arvados_version" "--url=https://arvados.org" "--description=PAM module for authenticating shell logins using Arvados API tokens" --depends libpam-python
345     fi
346 fi
347
348 # The FUSE driver
349 fpm_build_virtualenv "arvados-fuse" "services/fuse"
350
351 # The node manager
352 fpm_build_virtualenv "arvados-node-manager" "services/nodemanager"
353
354 # The Docker image cleaner
355 fpm_build_virtualenv "arvados-docker-cleaner" "services/dockercleaner" "python3"
356
357 # The Arvados crunchstat-summary tool
358 fpm_build_virtualenv "crunchstat-summary" "tools/crunchstat-summary"
359
360 # Forked libcloud
361 if test_package_presence "$PYTHON2_PKG_PREFIX"-apache-libcloud "$LIBCLOUD_PIN" python 2
362 then
363   LIBCLOUD_DIR=$(mktemp -d)
364   (
365       cd $LIBCLOUD_DIR
366       git clone $DASHQ_UNLESS_DEBUG https://github.com/curoverse/libcloud.git .
367       git checkout $DASHQ_UNLESS_DEBUG apache-libcloud-$LIBCLOUD_PIN
368       # libcloud is absurdly noisy without -q, so force -q here
369       OLD_DASHQ_UNLESS_DEBUG=$DASHQ_UNLESS_DEBUG
370       DASHQ_UNLESS_DEBUG=-q
371       handle_python_package
372       DASHQ_UNLESS_DEBUG=$OLD_DASHQ_UNLESS_DEBUG
373   )
374
375   # libcloud >= 2.3.0 now requires python-requests 2.4.3 or higher, otherwise
376   # it throws
377   #   ImportError: No module named packages.urllib3.poolmanager
378   # when loaded. We only see this problem on ubuntu1404, because that is our
379   # only supported distribution that ships with a python-requests older than
380   # 2.4.3.
381   fpm_build $LIBCLOUD_DIR "$PYTHON2_PKG_PREFIX"-apache-libcloud "" python "" --iteration 2 --depends 'python-requests >= 2.4.3'
382   rm -rf $LIBCLOUD_DIR
383 fi
384
385 # Build the API server package
386 test_rails_package_presence arvados-api-server "$WORKSPACE/services/api"
387 if [[ "$?" == "0" ]]; then
388   handle_rails_package arvados-api-server "$WORKSPACE/services/api" \
389       "$WORKSPACE/agpl-3.0.txt" --url="https://arvados.org" \
390       --description="Arvados API server - Arvados is a free and open source platform for big data science." \
391       --license="GNU Affero General Public License, version 3.0"
392 fi
393
394 # Build the workbench server package
395 test_rails_package_presence arvados-workbench "$WORKSPACE/apps/workbench"
396 if [[ "$?" == "0" ]] ; then
397   (
398       set -e
399       cd "$WORKSPACE/apps/workbench"
400
401       # We need to bundle to be ready even when we build a package without vendor directory
402       # because asset compilation requires it.
403       bundle install --system >"$STDOUT_IF_DEBUG"
404
405       # clear the tmp directory; the asset generation step will recreate tmp/cache/assets,
406       # and we want that in the package, so it's easier to not exclude the tmp directory
407       # from the package - empty it instead.
408       rm -rf tmp
409       mkdir tmp
410
411       # Set up application.yml and production.rb so that asset precompilation works
412       \cp config/application.yml.example config/application.yml -f
413       \cp config/environments/production.rb.example config/environments/production.rb -f
414       sed -i 's/secret_token: ~/secret_token: xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx/' config/application.yml
415       sed -i 's/keep_web_url: false/keep_web_url: exampledotcom/' config/application.yml
416
417       RAILS_ENV=production RAILS_GROUPS=assets bundle exec rake npm:install >/dev/null
418       RAILS_ENV=production RAILS_GROUPS=assets bundle exec rake assets:precompile >/dev/null
419
420       # Remove generated configuration files so they don't go in the package.
421       rm config/application.yml config/environments/production.rb
422   )
423
424   if [[ "$?" != "0" ]]; then
425     echo "ERROR: Asset precompilation failed"
426     EXITCODE=1
427   else
428     handle_rails_package arvados-workbench "$WORKSPACE/apps/workbench" \
429         "$WORKSPACE/agpl-3.0.txt" --url="https://arvados.org" \
430         --description="Arvados Workbench - Arvados is a free and open source platform for big data science." \
431         --license="GNU Affero General Public License, version 3.0"
432   fi
433 fi
434
435 # clean up temporary GOPATH
436 rm -rf "$GOPATH"
437
438 exit $EXITCODE